<script>
    export let xScale;
    export let subplot;
    export let clip_path_url;

    $: leftMargin = xScale.range()[0];
    $: rightMargin = xScale.range()[1];

    function getNested(obj, ...args) {
        return args.reduce((obj, level) => obj && obj[level], obj);
    }
    let annot_background_colors = getNested(
        subplot,
        "annot_options",
        "annot_background_colors",
    );
    if (!annot_background_colors) {
        annot_background_colors = [];
    }

    let annot_font_height = 11;
</script>

<g class="optional_annotation_background">
    {#each annot_background_colors as annot_background_color}
        <rect
            x={leftMargin}
            y={subplot.computed.yScale(annot_background_color.y1)}
            width={rightMargin - leftMargin}
            height={subplot.computed.yScale(annot_background_color.y0) -
                subplot.computed.yScale(annot_background_color.y1)}
            fill={annot_background_color.color}
            fill-opacity={annot_background_color.opacity}
            clip-path={clip_path_url} />
    {/each}
</g>
